searchNodes=[{"doc":"Default module for the RabbitMQ admin client. Configuration This module uses the ExRabbitMQAdmin.Client macro, and can be configured in config.exs . # config.ex config :ex_rabbitmq_admin , ExRabbitMQAdmin , base_url : &quot;https://rabbitmq.example.com:15672&quot; , username : &quot;guest&quot; , password : &quot;guest&quot; Examples Create a client, add basic auth by reading default values from config and list all virtual hosts running in the RabbitMQ cluster. iex&gt; ExRabbitMQAdmin . client ( ) |&gt; ExRabbitMQAdmin . add_basic_auth_middleware ( ) |&gt; ExRabbitMQAdmin.Vhost . list_vhosts ( ) { :ok , % Tesla.Env { status : 200 , body : [ ... ] } }","ref":"ExRabbitMQAdmin.html","title":"ExRabbitMQAdmin","type":"module"},{"doc":"Returns a Tesla.Client with Tesla.Middleware.BasicAuth middleware configured.","ref":"ExRabbitMQAdmin.html#add_basic_auth_middleware/1","title":"ExRabbitMQAdmin.add_basic_auth_middleware/1","type":"function"},{"doc":"","ref":"ExRabbitMQAdmin.html#add_basic_auth_middleware/2","title":"ExRabbitMQAdmin.add_basic_auth_middleware/2","type":"function"},{"doc":"Returns a Tesla.Client with Tesla.Middleware.BearerAuth middleware configured.","ref":"ExRabbitMQAdmin.html#add_bearer_auth_middleware/2","title":"ExRabbitMQAdmin.add_bearer_auth_middleware/2","type":"function"},{"doc":"Returns a Tesla.Client with Tesla.Middleware.Query middleware configured.","ref":"ExRabbitMQAdmin.html#add_query_middleware/2","title":"ExRabbitMQAdmin.add_query_middleware/2","type":"function"},{"doc":"","ref":"ExRabbitMQAdmin.html#add_query_middleware/3","title":"ExRabbitMQAdmin.add_query_middleware/3","type":"function"},{"doc":"Adds Tesla.Middleware.BasicAuth middleware to given Tesla.Client middlewares. Uses username and password from keyword opts, or if omitted, read credentials from config.exs .","ref":"ExRabbitMQAdmin.html#basic_auth_middleware/1","title":"ExRabbitMQAdmin.basic_auth_middleware/1","type":"function"},{"doc":"","ref":"ExRabbitMQAdmin.html#basic_auth_middleware/2","title":"ExRabbitMQAdmin.basic_auth_middleware/2","type":"function"},{"doc":"Adds Tesla.Middleware.BearerAuth middleware to given Tesla.Client middlewares.","ref":"ExRabbitMQAdmin.html#bearer_auth_middleware/2","title":"ExRabbitMQAdmin.bearer_auth_middleware/2","type":"function"},{"doc":"Returns a Tesla.Client with Tesla.Middleware.BaseUrl , Tesla.Middleware.Logger and Tesla.Middleware.JSON middleware configured.","ref":"ExRabbitMQAdmin.html#client/0","title":"ExRabbitMQAdmin.client/0","type":"function"},{"doc":"","ref":"ExRabbitMQAdmin.html#client/1","title":"ExRabbitMQAdmin.client/1","type":"function"},{"doc":"Adds Tesla.Middleware.Query middleware to given Tesla.Client middlewares.","ref":"ExRabbitMQAdmin.html#query_middleware/2","title":"ExRabbitMQAdmin.query_middleware/2","type":"function"},{"doc":"Macro for creating RabbitMQ HTTP API client. Configuration Some options, such as e.g. base_url can be read from config. If you want to use this macro in a module, you can add a corresponding entry in your config.exs file to configure the client. # config.ex config :my_app , MyApp.RabbitClient , base_url : &quot;https://rabbitmq.example.com:15672&quot; , username : &quot;guest&quot; , password : &quot;guest&quot; Parameters otp_app - Namespace used to look up configuration values such as base_url and others. Example defmodule MyApp.RabbitClient do use ExRabbitMQAdmin.Client , otp_app : :my_app end","ref":"ExRabbitMQAdmin.Client.html","title":"ExRabbitMQAdmin.Client","type":"module"},{"doc":"This module contains functions for interacting with RabbitMQ queues.","ref":"ExRabbitMQAdmin.Queue.html","title":"ExRabbitMQAdmin.Queue","type":"module"},{"doc":"Delete an existing queue under a virtual host. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to delete. :if_empty ( boolean/0 ) - If true, prevent deleting the queue if it contains any messages. This option is not supported by quorum queues. :if_unused ( boolean/0 ) - If true, prevent deleting the queue if it has any consumers. This option is not supported by quorum queues.","ref":"ExRabbitMQAdmin.Queue.html#delete_queue/4","title":"ExRabbitMQAdmin.Queue.delete_queue/4","type":"function"},{"doc":"Get an individual queue under a virtual host by name. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to get.","ref":"ExRabbitMQAdmin.Queue.html#get_queue/3","title":"ExRabbitMQAdmin.Queue.get_queue/3","type":"function"},{"doc":"List all bindings for a queue under a virtual host. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to get bindings for.","ref":"ExRabbitMQAdmin.Queue.html#list_queue_bindings/3","title":"ExRabbitMQAdmin.Queue.list_queue_bindings/3","type":"function"},{"doc":"List all queues running on the RabbitMQ cluster. Params client - Tesla client used to perform the request. :page ( non_neg_integer/0 ) - Page number to fetch if paginating the results. The default value is 1 . :page_size ( non_neg_integer/0 ) - Number of elements per page, defaults to 100. The default value is 100 . :name ( String.t/0 ) - Filter by name, for example queue name, exchange name, etc. :use_regex ( boolean/0 ) - Enables regular expression for the param name . The default value is false .","ref":"ExRabbitMQAdmin.Queue.html#list_queues/2","title":"ExRabbitMQAdmin.Queue.list_queues/2","type":"function"},{"doc":"List all queues in a given virtual host running on the RabbitMQ cluster. Params client - Tesla client used to perform the request. vhost - Name of the virtual host. :page ( non_neg_integer/0 ) - Page number to fetch if paginating the results. The default value is 1 . :page_size ( non_neg_integer/0 ) - Number of elements per page, defaults to 100. The default value is 100 . :name ( String.t/0 ) - Filter by name, for example queue name, exchange name, etc. :use_regex ( boolean/0 ) - Enables regular expression for the param name . The default value is false .","ref":"ExRabbitMQAdmin.Queue.html#list_vhost_queues/3","title":"ExRabbitMQAdmin.Queue.list_vhost_queues/3","type":"function"},{"doc":"Perform an action on a queue. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to perform actions for. action - type: atom , Action to perform. Currently only supports :sync and :cancel_sync","ref":"ExRabbitMQAdmin.Queue.html#perform_queue_action/4","title":"ExRabbitMQAdmin.Queue.perform_queue_action/4","type":"function"},{"doc":"Purge all messages on a queue under a virtual host. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to purge messages from.","ref":"ExRabbitMQAdmin.Queue.html#purge_queue/3","title":"ExRabbitMQAdmin.Queue.purge_queue/3","type":"function"},{"doc":"Create a new queue under a virtual host. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to get. :auto_delete ( boolean/0 ) - If true, automatically delete the queue when the last consumer disconnects. The default value is false . :durable ( boolean/0 ) - If true, messages are persisted on disk. This can lead to lower throughput, but better data consistency. The default value is true . :node ( String.t/0 ) - If set, start the queue on given node name. :arguments (map of String.t/0 keys and term/0 values) - Optional queue arguments (x-arguments) passed to RabbitMQ when creating the queue. Please consult the official documentation for supported arguments (as they vary for queue type and installed plugins).","ref":"ExRabbitMQAdmin.Queue.html#put_queue/4","title":"ExRabbitMQAdmin.Queue.put_queue/4","type":"function"},{"doc":"Receive messages from a queue under a virtual host. Please not that this is not an optimal way to consume messages from a queue. Consider using a library like AMQP for your daily dose of messages. Params client - Tesla client used to perform the request. vhost - type: string , Virtual host for the queue. queue - type: string , Name of the queue to receive messages from. :count ( pos_integer/0 ) - Maximum number of messages to receive. You may get fewer messages if the queue cannot immediately provide them. The default value is 1 . :ackmode - Required. Determines if the messages will be removed from the queue. If set to ack_requeue_true or reject_requeue_true , the messages will be re-queued. If set to ack_requeue_false , or reject_requeue_false , they will be removed. :encoding - If set to auto , message payload will be returned as string if it is valid UTF-8, or base64 encoded otherwise. If set to base64 message payload will always be base64 encoded. The default value is :auto . :truncate ( pos_integer/0 ) - If present, truncate the message payload if larger than given size (in bytes).","ref":"ExRabbitMQAdmin.Queue.html#receive_queue_messages/4","title":"ExRabbitMQAdmin.Queue.receive_queue_messages/4","type":"function"},{"doc":"This module contains functions for interacting with RabbitMQ users.","ref":"ExRabbitMQAdmin.User.html","title":"ExRabbitMQAdmin.User","type":"module"},{"doc":"Delete all users in given list. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#bulk_delete_users/2","title":"ExRabbitMQAdmin.User.bulk_delete_users/2","type":"function"},{"doc":"Deletes an individual user by given name. Params client - Tesla client used to perform the request. user - type: string , required: true","ref":"ExRabbitMQAdmin.User.html#delete_user/2","title":"ExRabbitMQAdmin.User.delete_user/2","type":"function"},{"doc":"Get an individual user by name. Params client - Tesla client used to perform the request. user - type: string , required: true","ref":"ExRabbitMQAdmin.User.html#get_user/2","title":"ExRabbitMQAdmin.User.get_user/2","type":"function"},{"doc":"Get all permissions for an individual user. Params client - Tesla client used to perform the request. user - type: string , required: true","ref":"ExRabbitMQAdmin.User.html#get_user_permissions/2","title":"ExRabbitMQAdmin.User.get_user_permissions/2","type":"function"},{"doc":"Get all topic permissions for an individual user. Params client - Tesla client used to perform the request. user - type: string , required: true","ref":"ExRabbitMQAdmin.User.html#get_user_topic_permissions/2","title":"ExRabbitMQAdmin.User.get_user_topic_permissions/2","type":"function"},{"doc":"Hash the given password using the hashing algorithm described here . RabbitMQ by default relies on (weak) hashed password, but we're enforcing the strongest supported hashing algorithm (sha512). If possible, avoid using passwords and authenticate using other means such as TLS certificates . Params password - type: string , required: true","ref":"ExRabbitMQAdmin.User.html#hash_password/1","title":"ExRabbitMQAdmin.User.hash_password/1","type":"function"},{"doc":"List all users in the RabbitMQ cluster. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#list_users/1","title":"ExRabbitMQAdmin.User.list_users/1","type":"function"},{"doc":"List users in the RabbitMQ cluster that have no access to any virtual host. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.User.html#list_users_without_permissions/1","title":"ExRabbitMQAdmin.User.list_users_without_permissions/1","type":"function"},{"doc":"Create a new user with given name. RabbitMQ currently only supports weak password hashing algorithms, and should be avoided if possible. If passing a blank password, a password-less user will be created. This user will not be able to authenticate with basic auth, and must use other means (such as TLS certificates). Params client - Tesla client used to perform the request. user - type: string , required: true :password ( String.t/0 ) - Required. The password that will be used for the created user. All passwords will be hashed using the rabbit_password_hashing_sha512 hashing algorithm before sent to over the wire. If blank password, users will not be able to login using a password, but other mechanisms like client certificates may be used. :tags ( String.t/0 ) - Required. Comma-separated list of tags for the user. Currently only administrator , monitoring and management are recognized.","ref":"ExRabbitMQAdmin.User.html#put_user/3","title":"ExRabbitMQAdmin.User.put_user/3","type":"function"},{"doc":"This module contains functions for interacting with RabbitMQ virtual hosts.","ref":"ExRabbitMQAdmin.Vhost.html","title":"ExRabbitMQAdmin.Vhost","type":"module"},{"doc":"Delete a specific virtual host by name. Params client - Tesla client used to perform the request. name - type: string , The name of the virtual host that should be deleted.","ref":"ExRabbitMQAdmin.Vhost.html#delete_vhost/2","title":"ExRabbitMQAdmin.Vhost.delete_vhost/2","type":"function"},{"doc":"Get an individual virtual host by name. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#get_vhost/2","title":"ExRabbitMQAdmin.Vhost.get_vhost/2","type":"function"},{"doc":"List all open channels for a specific virtual host. Optionally pass pagination parameters to filter channels. Params client - Tesla client used to perform the request. name - type: string , required: true :page ( non_neg_integer/0 ) - Page number to fetch if paginating the results. The default value is 1 . :page_size ( non_neg_integer/0 ) - Number of elements per page, defaults to 100. The default value is 100 . :name ( String.t/0 ) - Filter by name, for example queue name, exchange name, etc. :use_regex ( boolean/0 ) - Enables regular expression for the param name . The default value is false .","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_channels/3","title":"ExRabbitMQAdmin.Vhost.list_vhost_channels/3","type":"function"},{"doc":"List all open open connections in a specific virtual host. Optionally pass pagination parameters to filter connections. Params client - Tesla client used to perform the request. name - type: string , required: true :page ( non_neg_integer/0 ) - Page number to fetch if paginating the results. The default value is 1 . :page_size ( non_neg_integer/0 ) - Number of elements per page, defaults to 100. The default value is 100 . :name ( String.t/0 ) - Filter by name, for example queue name, exchange name, etc. :use_regex ( boolean/0 ) - Enables regular expression for the param name . The default value is false .","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_connections/3","title":"ExRabbitMQAdmin.Vhost.list_vhost_connections/3","type":"function"},{"doc":"List all permissions for a specific virtual host. Params client - Tesla client used to perform the request. name - type: string , The name of the vhost to list permissions for.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_permissions/2","title":"ExRabbitMQAdmin.Vhost.list_vhost_permissions/2","type":"function"},{"doc":"List all topic permissions for a specific virtual host. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhost_topic_permissions/2","title":"ExRabbitMQAdmin.Vhost.list_vhost_topic_permissions/2","type":"function"},{"doc":"List all virtual hosts running on the RabbitMQ cluster. Params client - Tesla client used to perform the request.","ref":"ExRabbitMQAdmin.Vhost.html#list_vhosts/1","title":"ExRabbitMQAdmin.Vhost.list_vhosts/1","type":"function"},{"doc":"Create a new virtual host with given name. Params client - Tesla client used to perform the request. name - type: string , required: true :description ( String.t/0 ) - Optional description for virtual host. The default value is &quot;&quot; . :tags ( String.t/0 ) - Tags is an optional comma-separated list of tags. The default value is &quot;&quot; .","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost/3","title":"ExRabbitMQAdmin.Vhost.put_vhost/3","type":"function"},{"doc":"Set permissions for a user on a specific virtual host. RabbitMQ permissions are defined as triplets of regular expressions. Please consult the official documentation for more details. Params client - Tesla client used to perform the request. name - type: string , The name of the vhost to assign permissions for. user - type: string , The username to assign permissions for. :configure ( String.t/0 ) - Required. A regular expression that will determine the configure permissions for the given resource. Defaults to deny-all. The default value is &quot;^$&quot; . :write ( String.t/0 ) - Required. A regular expression that will determine the write permissions for the given resource. Defaults to deny-all. The default value is &quot;^$&quot; . :read ( String.t/0 ) - Required. A regular expression that will determine the read permissions for the given resource. Defaults to deny-all. The default value is &quot;^$&quot; .","ref":"ExRabbitMQAdmin.Vhost.html#put_vhost_permissions/4","title":"ExRabbitMQAdmin.Vhost.put_vhost_permissions/4","type":"function"},{"doc":"Start a specific virtual host on given node. Params client - Tesla client used to perform the request. name - type: string , The name of the virtual host that should be started. node - type: string , The name of the node that the virtual host should be started on.","ref":"ExRabbitMQAdmin.Vhost.html#start_vhost/3","title":"ExRabbitMQAdmin.Vhost.start_vhost/3","type":"function"},{"doc":"Simple client library for the RabbitMQ HTTP API , built on Tesla . Read the full documentation here . Supported functionality [ ] Basic information endpoints (listing connections, channels, nodes, and so on) [x] Client adapter configuration [x] User management endpoints [x] Virtual host endpoints [x] Queue endpoints [ ] Exchange endpoints [ ] Bindings endpoints [ ] Parameters [ ] Policies endpoints [ ] Operator endpoints [ ] Health check endpoints","ref":"readme.html","title":"ExRabbitMQAdmin","type":"extras"},{"doc":"This package is available in Hex , and can be installed by adding ex_rabbitmq_admin to your list of dependencies in mix.exs : def deps do [ { :ex_rabbitmq_admin , &quot;~&gt; 0.1.0&quot; } ] end Example usage First step is to set up some basic configuration in your config.exs file. # config.exs config :ex_rabbitmq_admin , ExRabbitMQAdmin , base_url : &quot;https://rabbitmq.example.com:56721&quot; Next, you can use the ExRabbitMQAdmin client from wherever you want. defmodule RabbitMQControl do alias ExRabbitMQAdmin @doc &quot;&quot;&quot; Creates a new user on the RabbitMQ cluster. &quot;&quot;&quot; def create_rabbit_user ( username , password ) do { :ok , % Tesla.Env { status : 201 } } = ExRabbitMQAdmin . client ( ) |&gt; ExRabbitMQAdmin . add_basic_auth_middleware ( username : &quot;rabbit-admin&quot; , password : &quot;secret-password&quot; ) |&gt; ExRabbitMQAdmin.User . put_user ( username , password : password , tags : &quot;moderator&quot; ) end # Or maybe you want to list virtual hosts def virtual_hosts do { :ok , % Tesla.Env { :status : 200 , body : response } } = ExRabbitMQAdmin . client ( ) |&gt; ExRabbitMQAdmin . add_basic_auth_middleware ( username : &quot;rabbit-admin&quot; , password : &quot;secret-password&quot; ) |&gt; ExRabbitMQAdmin.Vhost . list_vhosts ( ) end end","ref":"readme.html#installation","title":"ExRabbitMQAdmin - Installation","type":"extras"},{"doc":"The RabbitMQ HTTP API documentation is available here . Running the test suite $ mix coveralls.html","ref":"readme.html#contribution","title":"ExRabbitMQAdmin - Contribution","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Intility AS Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]